#define TEXTURED

#pragma include(builtInShaders/uber.vert.incl)
#pragma include(builtInShaders/utils/mathUtils.incl)

uniform float u_globalTime;
uniform float u_waterLevel;
uniform float u_xDistorCoeff;
uniform float u_yDistorCoeff;
uniform vec4 u_texCoord;

void main()
{
    updateScreenPosition();
    updateColor();

    vec2 coord = a_texCoord.xy;
    if(a_position.y - 50.0 > u_waterLevel) {
        coord.x = clamp(coord.x + u_texCoord[2] * sin(a_position.y / 120.0 + u_globalTime) * u_xDistorCoeff * 0.0112 * sin(a_position.y * PI / (2.0 * 96.0)), u_texCoord[0], u_texCoord[2] + u_texCoord[0]);
        coord.y = clamp(coord.y + u_texCoord[3] * sin(a_position.x / 60.0 + u_globalTime) * u_yDistorCoeff * 0.0112 * sin(a_position.y * PI / (2.0 * 96.0)), u_texCoord[1], u_texCoord[3] + u_texCoord[1]);
    }

    v_position = a_position;
    gl_Position = vec4(u_transform * vec3(a_position.xy, 1.0), 1.0);
    v_texCoord = coord;
}